import es, gamethread, random, popuplib, playerlib, cfglib, usermsg, langlib

info = es.AddonInfo()
info.name     = "SIC-Deathmatch"
info.version  = "4.1"
info.url      = "None"
info.basename = "sic_dm"
info.author   = "sicman_adrian"
es.ServerVar('sic_dm', info.version, info.name).makepublic()

player_dict = {}
weapons_dict = {}

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/deathmatch.cfg')
config.text("********************")
config.text(" Guns Menu Settings")
config.text("********************")
deathmatch_menu_enable   = config.cvar("deathmatch_menu_enable",   1, "This enables and Disables weapon menu")
deathmatch_random_weapons   = config.cvar("deathmatch_random_weapons",   0, "Disables Gun menu and Gives random weapons")
deathmatch_primaryweapons = config.cvar("deathmatch_primary_names",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry menu list")
deathmatch_secondary = config.cvar("deathmatch_pistol_names",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol menu list")
deathmatch_bot_primaryweapons = config.cvar("deathmatch_bot_primaryweapons",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry bot weapons")
deathmatch_bot_secondary = config.cvar("deathmatch_bot_secondary",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol bot weapons")
config.text("********************")
config.text("   Spawn Settings   ")
config.text("********************")
deathmatch_respawn_enabled   = config.cvar("deathmatch_respawn_enabled",   1, "Respawns a player")
deathmatch_deadtime   = config.cvar("deathmatch_deadtime",   0.1, "How long till they respawn")
deathmatch_givekevlar   = config.cvar("deathmatch_givekevlar",   1, "Give players Kevlar's")
deathmatch_grenades = config.cvar("deathmatch_grenades",   'hegrenade flashbang smokegrenade', "Nades givin to players")
config.text("********************")
config.text("     Disssolver     ")
config.text("********************")
deathmatch_deathtype = config.cvar("deathmatch_deathtype",      6, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
deathmatch_dissolvetime   = config.cvar("deathmatch_dissolvetime",   3, "How long bodie Stays")
config.text("\n")
config.text("*************************")
config.text("        Round End        ")
config.text("*************************")
deathmatch_roundend_enable   = config.cvar("deathmatch_roundend_enable",   1, "Enables rounds")
config.text("\n")
config.text("*************************")
config.text("Spawn Protection Settings")
config.text("*************************")
deathmatch_spawn_protection   = config.cvar("deathmatch_spawn_protection",   1, "Enable or Disable Spawn Protection")
deathmatch_protection_time   = config.cvar("deathmatch_protection_time",   2.5, "Time Protected")
deathmatch_protection_alpha   = config.cvar("deathmatch_protection_alpha",   100, " Alpha When spawned ,100 half invisible, Default 255")
config.text("\n")
'''
config.text("*************************")
config.text("       GamesModes        ")
config.text("*************************")
deathmatch_gamemodes_enable = config.cvar("deathmatch_gamemodes_enable",   1, "Enable/Disable gamemodes")
deathmatch_gamemodes_ffa = config.cvar("deathmatch_gamemodes_ffa",   0, "Enable/Disable Free For All")
deathmatch_gamemodes_redvsblue = config.cvar("deathmatch_gamemodes_redvsblue",   0, "Red Vs Blue Gamemode,So far Red vs blue Is just Blue and Red Master Chief skins for both teams")
deathmatch_gamemodes_headshotonly = config.cvar("deathmatch_gamemodes_headshotonly",   0, "Head Shot Only Gamemode")
config.text("\n")
config.text("**************************")
config.text("       Red Vs Blue        ")
config.text("**************************")
deathmatch_redvsblue_disable_downloads = config.cvar("deathmatch_redvsblue_disable_downloads",   0, "Change to 1 if you are using fast downloads or mani")
deathmatch_redvsblue_redmodel_folder   = config.cvar("deathmatch_redvsblue_redmodel_folder",   'models/player/bic/', "Ct model path used for downloads")
deathmatch_redvsblue_bluemodel_folder   = config.cvar("deathmatch_redvsblue_bluemodel_folder",   'models/player/bic/', "T's Model path used for downloads")
deathmatch_redvsblue_red_model   = config.cvar("deathmatch_redvsblue_red_model",   'models/player/bic/t_arctic.mdl', "Terriost Model")
deathmatch_redvsblue_blue_model   = config.cvar("deathmatch_redvsblue_blue_model",   'models/player/bic/ct_sas.mdl', "Ct Model")
deathmatch_redvsblue_pushscale = config.cvar("deathmatch_redvsblue_pushscale",   400, "Makes Ragdolls fly")
deathmatch_redvsblue_energyhe = config.cvar("deathmatch_redvsblue_energyhe",   1, "Hegrenades will be like the energy grenades in halo")
config.text("\n")
'''
config.text("*************************")
config.text("         Extras          ")
config.text("*************************")
deathmatch_noblock   = config.cvar("deathmatch_noblock",   1, "Enable and Disables noblock Allowing people to walk throught other players")
deathmatch_spec   = config.cvar("deathmatch_spec",   1, "Allows players to go spec using !spec in chat")
deathmatch_unlimitednade   = config.cvar("deathmatch_unlimitednade",   1, "Gives Players Unlimited Nades")
config.text("\n")
config.text("*************************")
config.text("      SpawnPoints        ")
config.text("*************************")
deathmatch_spawnpoints   = config.cvar("deathmatch_spawnpoints",   0, "Loads Spawnpoints")

config.write()

player_dict = {}
weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}
text = None
weapon_list = ['M4A1','AK47','AWP','Scout','SG552', 'Galil','Famas','SG550','AUG','m249','G3SG1','UMP45','MP5NAVY','M3','xm1014','TMP','Mac10', 'P90','Usp','Glock','Deagle','P228','Elite','FiveSeven']
'''
model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(deathmatch_redvsblue_redmodel_folder)
model_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(deathmatch_redvsblue_bluemodel_folder)
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/redmc/'
material_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/bluemc/'
'''

class player:
    def __init__(self, userid):
        self.userid = userid
    def spawn(self):
        if int(deathmatch_menu_enable):
            if es.isbot(self.userid) or weapons_dict[self.userid].menu == 3:
                weapons_dict[self.userid].Giverandom()
            else:
                if int(deathmatch_menu_enable):
                    if weapons_dict[self.userid].menu == 1:
                        sicdm_gunsmenu.unsend(self.userid)
                        popuplib.send('sicdm_gunsmenu', self.userid)
                    elif weapons_dict[self.userid].menu == 2:
                        weapons_dict[self.userid].Giveweapons()
                    #elif weapons_dict[self.userid].menu == 3:
                    #    weapons_dict[self.userid].Giverandom()
        if int(deathmatch_givekevlar):
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s item_assaultsuit' % self.userid)
        if int(deathmatch_noblock):
            es.setplayerprop(self.userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
        if int(deathmatch_spawn_protection):
            sp(self.userid)
    def dissolve(self):
        userid = str(self.userid)
        if int(deathmatch_deathtype) == 6:
            mode = random.randint(1,5)
        else:
            mode = deathmatch_deathtype
        if mode == 1:
            es.delayed(deathmatch_dissolvetime, 'es_fire %s cs_ragdoll kill' % self.userid)
        else:
            '''
            es.give(userid,'env_entity_dissolver')
            es.fire(userid,'env_entity_dissolver', 'addoutput', "target cs_ragdoll")
            es.fire(userid,'env_entity_dissolver', 'addoutput', "magnitude 1")
            es.fire(userid,'env_entity_dissolver', 'addoutput', "dissolvetype %s" % (mode-2))
            es.fire(userid,'env_entity_dissolver', 'dissolve')
            '''
            index = es.createentity('env_entity_dissolver', self.userid)
            es.entitysetvalue(index, 'target', 'cs_ragdoll')
            es.entitysetvalue(index, 'magnitude', '1')
            es.entitysetvalue(index, 'dissolvetype', mode)
            es.spawnentity(index)
            es.delayed(int(deathmatch_dissolvetime), 'es_xfire %s %s Dissolve'%(self.userid, self.userid))


class sp:
    def __init__(self,userid):
        self.userid = userid
        self.protected = 0
        myPlayer = playerlib.getPlayer(self.userid)
        es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_lifeState', 0)
        myPlayer.set("color", (255, 255, 255, deathmatch_protection_alpha))
        self.protected = 1
        gamethread.delayedname(deathmatch_protection_time, 'removeprotection%s'% self, self.removeprotect)
    def removeprotect(self):
        myPlayer = playerlib.getPlayer(self.userid)
        myPlayer.set("color", (255, 255, 255, 255))
        es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_lifeState', 512)
        self.protected = 0


class weapons:
    def __init__(self,userid):
        self.userid = userid
        self.primary = 0
        self.secondary = 0
        self.menu = 1
    def strip(self):
        es.server.queuecmd('es_xfire %s player_weaponstrip kill' % self.userid)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % self.userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % self.userid)
    def Giveweapons(self):
        self.strip()
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % self.userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, self.primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, self.secondary))
    def Giverandom(self):
        self.strip()
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % self.userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_primaryweapons).split())))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_secondary).split())))
    def Idleweapons(self):
        entity = es.createentitylist()
        for index in entity:
            classname = entity[index]['classname']
            if classname.startswith('weapon_'):
                if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
                    es.remove(index)


class Weaponmenu:
    def __init__(self):
        global sicdm_gunsmenu, sicdm_primarymenu, sicdm_pistolmenu
        sicdm_gunsmenu = popuplib.create('sicdm_gunsmenu')
        for line in ['Deathmatch','----------------------','->1. New weapons','->2. Same weapons','->3. Same weapons every time','->4. Random weapons','->5. Random weapons every time','----------------------']:
            sicdm_gunsmenu.addline(line)
        sicdm_gunsmenu.menuselect = self.gunsmenu
        sicdm_primarymenu = popuplib.easymenu('sicdm_primarymenu', '_popup_choice', self.addgun)
        sicdm_primarymenu.settitle('Primary weapons')
        for prim in str(deathmatch_primaryweapons).split(): sicdm_primarymenu.addoption(prim, prim)
        sicdm_pistolmenu = popuplib.easymenu('sicdm_pistolmenu', '_popup_choice', self.addgun)
        sicdm_pistolmenu.settitle('Pistols')
        for pist in str(deathmatch_secondary).split(): sicdm_pistolmenu.addoption(pist, pist)
    def gunsmenu(self, userid, choice, popupid):
        userid = str(userid)
        if choice == 1:
            popuplib.send('sicdm_pistolmenu', userid)
            es.cexec(userid, 'play buttons/button24')
        elif choice == 2:
            if weapons_dict[userid].primary in weapon_list and weapons_dict[userid].secondary in weapon_list:
                weapons_dict[userid].Giveweapons()
                es.cexec(userid, 'play buttons/button24')
            else:
                sicdm_gunsmenu.unsend(userid)
                sicdm_gunsmenu.send(userid)
        elif choice == 3:
              if weapons_dict[userid].primary in weapon_list and weapons_dict[userid].secondary in weapon_list:
                  weapons_dict[userid].Giveweapons()
                  weapons_dict[userid].menu = 2
                  es.cexec(userid, 'play buttons/button24')
              else:
                  sicdm_gunsmenu.unsend(userid)
                  sicdm_gunsmenu.send(userid)
        elif choice == 4:
              weapons_dict[userid].Giverandom()
              es.cexec(userid, 'play buttons/button24')
        elif choice == 5:
              weapons_dict[userid].Giverandom()
              es.cexec(userid, 'play buttons/button24')
              self.menu = 3
    def addgun(self, userid, choice, popupid):
        for prim in str(deathmatch_primaryweapons).split():
            if str(prim) == str(choice):
                weapons_dict[str(userid)].primary = choice
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (str(userid), weapons_dict[str(userid)].primary))
        for sec in str(deathmatch_secondary).split():
            if str(sec) == str(choice):
                weapons_dict[str(userid)].secondary = choice
                popuplib.send('sicdm_primarymenu', userid)
                weapons_dict[str(userid)].strip()
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % str(userid))
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (str(userid), weapons_dict[str(userid)].secondary))

def load():
    global text
    if not es.exists('command', 'guns'):
        es.regsaycmd('guns', 'deathmatch/mainmenu')
    if not es.exists('command', '!spec'):
        es.regsaycmd('!spec', 'deathmatch/spec')
    text = langlib.Strings(es.getAddonPath("deathmatch") + "/strings.ini")
    es.msg('#multi', text("load"))
    config.execute()
    es.server.queuecmd('es_load deathmatch/dm/admin')
    es.dbgmsg(0,'Admin Menu Loaded')
    es.flags('remove', 'cheat', 'endround')
    if int(deathmatch_spawn_protection):
        es.msg('#multi', text("spawn load"))
    if int(deathmatch_random_weapons):
        deathmatch_menu_enable = 0
    if int(deathmatch_spawnpoints):
        es.server.queuecmd('es_load deathmatch/dm/spawnpoints')
    Weaponsmenu = Weaponmenu()
    es.doblock('corelib/noisy_on')
    for userid in es.getUseridList():
        userid = str(userid)
        weapons_dict[userid] = weapons(userid)
        player_dict[userid] = player(userid)

def unload():
    for popup in ['sicdm_gunsmenu','sicdm_pistolmenu','sicdm_primarymenu']:
        popuplib.delete(popup)
    es.server.queuecmd('es_unload deathmatch/spawnpoints')
    if es.exists('command', 'guns'):
        es.unregsaycmd('guns')
    if es.exists('command', '!spec'):
        es.unregsaycmd('!spec')
    es.doblock('corelib/noisy_off')
    for userid in es.getUseridList():
        userid = str(userid)
        del player_dict[userid]
        del  weapons_dict[userid]
    es.msg('#multi', text("unload"))
    if int(deathmatch_spawn_protection):
        es.msg('#multi', text("spawn unload"))
    es.server.queuecmd('es_unload deathmatch/dm/admin')
    es.dbgmsg(0,'Admin Menu Unloaded')

def respawn(userid):
    es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
    es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)
    es.spawnplayer(userid)

def weapon_reload(ev):
    myPlayer = playerlib.getPlayer(ev['userid'])
    weapon = myPlayer.attributes['weapon']
    if weapon in weapon_ammo_dict:
        myPlayer.set('ammo',(weapon,weapon_ammo_dict[weapon]))

def player_activate(ev):
    weapons_dict[ev['userid']] = weapons(ev['userid'])
    player_dict[ev['userid']] = player(ev['userid'])

def player_spawn(ev):
    if ev['es_userteam'] >= '2':
        player_dict[ev['userid']].spawn()

def player_death(ev):
    userid = ev['userid']
    if int(deathmatch_respawn_enabled) == 1:
        gamethread.cancelDelayed('respawn'+ ev['userid'])
        gamethread.delayedname(deathmatch_deadtime, 'respawn%s'% userid, respawn, userid)
    player_dict[userid].dissolve()
    weapons_dict[userid].Idleweapons()

def player_team(ev):
    userid = ev['userid']
    if int(deathmatch_respawn_enabled) == 1:
        if int(ev['team']) > 1:
            gamethread.cancelDelayed('respawn'+ ev['userid'])
            gamethread.delayedname(3, 'respawn%s'% userid, respawn, userid)

def player_disconnect(ev):
    if es.exists('userid', ev['userid']):
        del player_dict[ev['userid']]
        del weapons[ev['userid']]
        gamethread.cancelDelayed('removeprotect'+ ev['userid'])
        gamethread.cancelDelayed('respawn'+ ev['userid'])

def flashbang_detonate(ev):
    if not es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade):
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % ev['userid'])

def smokegrenade_detonate(ev):
    if not es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade):
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_smokegrenade' % ev['userid'])

def hegrenade_detonate(ev):
    if not es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade):
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_hegrenade' % ev['userid'])

def spec():
    if int(deathmatch_spec) == 1:
        es.server.queuecmd('es_changeteam %s 1'% es.getcmduserid())

def mainmenu():
    if int(deathmatch_menu_enable) == 1:
        popuplib.unsend('sicdm_gunsmenu', str(es.getcmduserid()))
        popuplib.send('sicdm_gunsmenu', str(es.getcmduserid()))
    else:
        es.tell(es.getcmduserid(), '#multi','Guns Menu is disabled')

def round_start(ev):
    userid = es.getuserid()
    roundtime = es.ServerVar("mp_roundtime") * 60 + es.ServerVar("mp_freezetime")
    gamethread.delayed(10, usermsg.hudhint, ('#all', text('hudhint')))
    if int(deathmatch_roundend_enable) == 1:
        gamethread.cancelDelayed('round_end')
        gamethread.delayedname(roundtime, 'round_end', es.server.queuecmd, 'endround')
    else:
        if userid:
            es.server.queuecmd('es_xfire %s func_hostage_rescue kill'% userid)
            es.server.queuecmd('es_xfire %s hostage_entity kill'% userid)
            es.server.queuecmd('es_xfire %s func_bomb_target kill'% userid)
            es.server.queuecmd('es_xfire %s func_buyzone Disable'%userid)
    es.fire(userid, 'game_weapon_manager', 'AddOutput', 'maxpieces 0')